<?php

namespace CRM\Controller;

use Zeedhi\Framework\DTO\Request;
use CRM\Traits\TResponse;
use CRM\Service\CrmDashboardService;

class CrmDashboardController
{
    protected $DashboardService;

    use TResponse;

    public function __construct(CrmDashboardService $DashboardService)
    {
        $this->DashboardService = $DashboardService;
    }

    public function dataBaseChartPie()
    {
        try {
            $data = $this->DashboardService->dataBaseChartPieService();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function dataBaseChartBarLead()
    {
        try {
            $data = $this->DashboardService->dataBaseChartBarLeadService();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function dataBaseChartThermometer()
    {
        try {
            $data = $this->DashboardService->dataBaseChartThermometerService();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function dataBaseCardTask()
    {
        try {
            $data = $this->DashboardService->dataBaseCardTaskService();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function dataBaseCardCommitment()
    {
        try {
            $data = $this->DashboardService->dataBaseCardCommitmentService();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function dataBaseCardOpportunity()
    {
        try {
            $data = $this->DashboardService->dataBaseCardOpportunityService();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function dataBaseCardOccurrences()
    {
        try {
            $data = $this->DashboardService->dataBaseCardOccurrencesService();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
