<?php

namespace CRM\Controller;

use CRM\Traits\TResponse;
use CRM\Service\EvolucaoService;
use Zeedhi\Framework\DTO\Request;

class EvolucaoController
{
    protected $EvolucaoService;

    use TResponse;

    public function __construct(EvolucaoService $EvolucaoService)
    {
        $this->EvolucaoService = $EvolucaoService;
    }

    public function getEvolutionTab(Request $request)
    {
        try {
            $data = $this->EvolucaoService->getEvolutionTab($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
