<?php

namespace CRM\Controller;

use Zeedhi\Framework\DTO\Request;
use CRM\Traits\TResponse;
use CRM\Service\Ger91600TipoDeAtividadeService;

class Ger91600TipoDeAtividadeController{

    protected $TipoDeAtividadeService;

    use TResponse;

    public function __construct(Ger91600TipoDeAtividadeService $TipoDeAtividadeService)
    {
        $this->TipoDeAtividadeService = $TipoDeAtividadeService;
    }

    public function getTypeOfActivity(){
        try {
          
            $data = $this->TipoDeAtividadeService->getTypeOfActivityService();
            $this->sendResponse($data, 200);

        } catch (\Exception $e) {
            $this->sendResponse(['error' => $e->getMessage(), 'code' => $e->getCode()], 500);
        }
    }

    public function getFieldOfActivity(){
        try {
          
            $data = $this->TipoDeAtividadeService->getFieldOfActivityService();
            $this->sendResponse($data, 200);

        } catch (\Exception $e) {
            $this->sendResponse(['error' => $e->getMessage(), 'code' => $e->getCode()], 500);
        }
    }

    public function saveNewActivity(Request $request){
        try {

            $data = $this->TipoDeAtividadeService->saveNewActivityService($request->getParameters());

        } catch (\Exception $e) {

            $this->sendResponse(['error' => $e->getMessage(), 'code' => $e->getCode()], 500);

        }
    }

    public function deleteActivity (Request $request) {
        try {
            $this->TipoDeAtividadeService->deleteActivityService($request->getParameters());
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}