<?php

namespace CRM\Service;

use CRM\Factory\CrmDashboardFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;

class CrmDashboardService
{

    protected $DashboardFactory;
    protected $Environment;
    protected $newCode;
    protected $connection;

    public function __construct(Environment $Environment, NewCode $newCode, EntityManager $entityManager, CrmDashboardFactory $DashboardFactory)
    {
        $this->DashboardFactory             = $DashboardFactory;
        $this->Environment                  = $Environment;
        $this->newCode                      = $newCode;
        $this->connection                   = $entityManager->getConnection();
    }

    public function dataBaseChartPieService()
    {
        try {
            $cdoperador = $this->Environment->getCdOperador();
            $nrorg = $this->Environment->getNrOrg();
            return $this->DashboardFactory->dataBaseChartPieFactory($cdoperador, $nrorg);
        } catch (\Exception $e) {
            $this->connection->rollback();
            throw $e;
        }
    }

    public function dataBaseChartBarLeadService()
    {
        try {
            $nrorg = $this->Environment->getNrOrg();
            return $this->DashboardFactory->dataBaseChartBarLeadFactory($nrorg);
        } catch (\Exception $e) {
            $this->connection->rollback();
            throw $e;
        }
    }

    public function dataBaseChartThermometerService()
    {
        try {
            $cdoperador = $this->Environment->getCdOperador();
            $nrorg = $this->Environment->getNrOrg();
            return $this->DashboardFactory->dataBaseChartThermometerFactory($cdoperador, $nrorg);
        } catch (\Exception $e) {
            $this->connection->rollback();
            throw $e;
        }
    }

    public function dataBaseCardTaskService()
    {
        try {
            $cdoperador = $this->Environment->getCdOperador();
            $cdoperadorAsString = "'" . $cdoperador . "'";
            return $this->DashboardFactory->dataBaseCardTaskFactory($cdoperadorAsString);
        } catch (\Exception $e) {
            $this->connection->rollback();
            throw $e;
        }
    }

    public function dataBaseCardCommitmentService()
    {
        try {
            $cdoperador = $this->Environment->getCdOperador();
            $cdoperadorAsString = "'" . $cdoperador . "'";
            return $this->DashboardFactory->dataBaseCardCommitmentFactory($cdoperadorAsString);
        } catch (\Exception $e) {
            $this->connection->rollback();
            throw $e;
        }
    }

    public function dataBaseCardOpportunityService()
    {
        try {
            $cdoperador = $this->Environment->getCdOperador();
            $cdoperadorAsString = "'" . $cdoperador . "'";
            return $this->DashboardFactory->dataBaseCardOpportunityFactory($cdoperadorAsString);
        } catch (\Exception $e) {
            $this->connection->rollback();
            throw $e;
        }
    }

    public function dataBaseCardOccurrencesService()
    {
        try {
            $nrorg = $this->Environment->getNrOrg();
            $cdoperador = $this->Environment->getCdOperador();
            $cdoperadorAsString = "'" . $cdoperador . "'";
            $nrorgAsString = "'" . $nrorg . "'";
            return $this->DashboardFactory->dataBaseCardOccurrencesFactory($cdoperadorAsString, $nrorgAsString);
        } catch (\Exception $e) {
            $this->connection->rollback();
            throw $e;
        }
    }
}
