<?php

namespace CRM\Service;

use CRM\Factory\CrmRamodeAtividadeFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;

class CrmRamodeAtividadeService
{

    protected $CrmRamodeAtividadeFactory;
    protected $environment;
    protected $newCode;
    protected $connection;

    public function __construct(Environment $environment, NewCode $newCode, EntityManager $entityManager, CrmRamodeAtividadeFactory $CrmRamodeAtividadeFactory)
    {
        $this->CrmRamodeAtividadeFactory    = $CrmRamodeAtividadeFactory;
        $this->environment                  = $environment;
        $this->newCode                      = $newCode;
        $this->connection                   = $entityManager->getConnection();
    }

    public function getBranchOfActivityService()
    {
        return $this->CrmRamodeAtividadeFactory->getBranchOfActivityFactory();
    }

    public function getFieldMarket()
    {
        return $this->CrmRamodeAtividadeFactory->getFieldMarket();
    }

    public function saveNewBranchService($rows)
    {
        $nrorg = $this->environment->getNrOrg();
        $cdoperador = $this->environment->getCdOperador();
        $cdnvativcli = 1;
        $this->connection->beginTransaction();
        try {
            foreach ($rows["DRG"] as $row) {
                if ($row["CDATIVCLI"] == 0) {
                    print_r($rows["DRG"]);
                    $cdativcli = $this->newCode->getCodeByTableName("ATIVCLIENTE", $nrorg, 1, 5, false);
                    $params = array(
                        "CDATIVCLI"      => $cdativcli,
                        "CDARVATIVCLI"   => $cdativcli,
                        "IDATIVO"        => $row["IDATIVO"],
                        "DSATIVCLI"      => $row["DSATIVCLI"],
                        "CDSEGMER"       => $row["CDSEGMER"],
                        "CDNVATIVCLI"    => $cdnvativcli,
                        "NRORG"          => $nrorg,
                        "NRORGINCLUSAO"  => $nrorg,
                        "NRORGULTATU"    => $nrorg,
                        "CDOPERINCLUSAO" => $cdoperador,
                        "CDOPERULTATU"   => $cdoperador
                    );
                    $this->CrmRamodeAtividadeFactory->insertNewBranchFactory($params);
                } else {

                    $params = array(
                        "CDATIVCLI"      => $row["CDATIVCLI"],
                        "CDARVATIVCLI"   => $row["CDATIVCLI"],
                        "IDATIVO"        => $row["IDATIVO"],
                        "DSATIVCLI"      => $row["DSATIVCLI"],
                        "CDSEGMER"       => $row["CDSEGMER"],
                        "CDNVATIVCLI"    => $cdnvativcli,
                        "NRORG"          => $nrorg,
                        "NRORGINCLUSAO"  => $nrorg,
                        "NRORGULTATU"    => $nrorg,
                        "CDOPERINCLUSAO" => $cdoperador,
                        "CDOPERULTATU"   => $cdoperador
                    );

                    $this->CrmRamodeAtividadeFactory->updateNewBranchFactory($params);
                }
            }
            $this->connection->commit();
        } catch (\Exception $e) {
            $this->connection->rollback();
            throw $e;
        }
    }

    public function deleteBranchOfActivityService($rows)
    {
        $this->connection->beginTransaction();
        try {
            if ($rows["CDAT"] == 0) {
                $params = implode(',', $rows["CDAT"]);
                $this->CrmRamodeAtividadeFactory->deleteBranchOfActivityFactory($params);
            } else {

                throw new \Exception("Esse Seguimento De Mercado Não Pode Ser Excluido, Pois Já Está Sendo Utilizada!");
            }
            $this->connection->commit();
        } catch (\Exception $e) {
            $this->connection->rollback();
            throw $e;
        }
    }
}
