/******************************************************************************/
/* Sistemas Integrados TECNISA                                                */
/*                                                                            */
/* Pedidos                                                                    */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/* Nome: 2804_EXPTRGO_ATUALIZA_STATUS_GRADE                                   */
/*                                                                            */
/* Descrio:                                                                 */
/* Atualizar o status da grade de distribuio                                */
/*                                                                            */
/* Criao:                                                                   */
/* 22/05/2009 - Welbert Gonalves Moitinha                                    */
/******************************************************************************/

CREATE OR REPLACE TRIGGER ATUALIZA_STATUS_GRADE
AFTER UPDATE ON NOTAFISCAL FOR EACH ROW
DECLARE
   V_IDREPLITRANS PAREXPEDICAO.IDREPLITRANS%TYPE;
   V_NRGRADEDISTR GRADEDISTR.NRGRADEDISTR%TYPE;
   V_CDVIATURA VIATURA.CDVIATURA%TYPE;
   V_COUNT INTEGER;
BEGIN

   BEGIN
      SELECT IDREPLITRANS
      INTO V_IDREPLITRANS
      FROM PAREXPEDICAO
      WHERE
         CDFILIAL = :NEW.CDFILIAL;
   EXCEPTION
      WHEN  NO_DATA_FOUND THEN
         V_IDREPLITRANS := NULL;
   END;
   IF (V_IDREPLITRANS = '3')THEN
/* BUSCA A GRADE E A VIATURA */
      BEGIN
         SELECT NRGRADEDISTR, CDVIATURA
         INTO V_NRGRADEDISTR, V_CDVIATURA
         FROM EXPEDICAO
         WHERE
            CDFILIAL = :NEW.CDFILIAL AND
            NREXPEDICAO = :NEW.NREXPEDICAO;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_NRGRADEDISTR := NULL;
            V_CDVIATURA := NULL;
      END;

      IF (V_NRGRADEDISTR IS NOT NULL) AND (V_CDVIATURA IS NOT NULL) THEN

         IF(:NEW.IDSTATUS = 'A')OR(:NEW.IDSTATUS = 'E')THEN
/* ATUALIZA OS ITENS DA GRADE */
            FOR C_ITEM IN (SELECT  NRPEDIDO, NRITEMPED, CDFILIALPED
                           FROM ITEMPRODUTO
                           WHERE
                              CDFILIAL = :NEW.CDFILIAL AND
                              NRLANCTONF = :NEW.NRLANCTONF) LOOP

               UPDATE ITGRADEDISTR
               SET IDSTATUSITGR = 'E'
               WHERE
                  CDFILIAL = C_ITEM.CDFILIALPED AND
                  NRGRADEDISTR = V_NRGRADEDISTR AND
                  NRPEDIDO = C_ITEM.NRPEDIDO AND
                  NRITEMPED = C_ITEM.NRITEMPED AND
                  CDVIATURA = V_CDVIATURA;
            END LOOP;

/* VERIFICA SE TODOS OS ITENS FORAM ENTREGUES*/
            SELECT COUNT(*)
              INTO V_COUNT
              FROM ITGRADEDISTR
             WHERE
                CDFILIAL = :NEW.CDFILIAL AND
                NRGRADEDISTR = V_NRGRADEDISTR AND
                IDSTATUSITGR = 'A';

            IF(V_COUNT = 0) THEN
               UPDATE GRADEDISTR
               SET IDSTATUSGRADE = 'C'
               WHERE
                  CDFILIAL = :NEW.CDFILIAL AND
                  NRGRADEDISTR = V_NRGRADEDISTR;
            END IF;
         ELSE
            IF(:NEW.IDSTATUS = 'P') AND((:OLD.IDSTATUS = 'A')OR( :OLD.IDSTATUS ='E')) THEN
               FOR C_ITEM IN (SELECT  NRPEDIDO, NRITEMPED, CDFILIALPED
                              FROM ITEMPRODUTO
                              WHERE
                                 CDFILIAL = :NEW.CDFILIAL AND
                                 NRLANCTONF = :NEW.NRLANCTONF) LOOP

                  UPDATE ITGRADEDISTR
                  SET IDSTATUSITGR = 'A'
                  WHERE
                     CDFILIAL = C_ITEM.CDFILIALPED AND
                     NRGRADEDISTR = V_NRGRADEDISTR AND
                     NRPEDIDO = C_ITEM.NRPEDIDO AND
                     NRITEMPED = C_ITEM.NRITEMPED AND
                     CDVIATURA = V_CDVIATURA;
               END LOOP;

               UPDATE GRADEDISTR
               SET IDSTATUSGRADE = 'A'
               WHERE
                  CDFILIAL = :NEW.CDFILIAL AND
                  NRGRADEDISTR = V_NRGRADEDISTR;

            END IF;
         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('ATUALIZA_STATUS_GRADE','5.07.000'); END;
/

